Subject: Re: bug#74881: 31.0.50; [PATCH] * lisp/vc/ediff-util.el: Remove temp files on kill-emacs

From: Lin Sun <[email-masked]>
Date: Sun, 29 Dec 2024 02:25:16 +0000

> From: Michael Heerdegen <[email-masked]>
> Sent: Saturday, December 28, 2024 05:49 PM
> > +(defun ediff--delete-temp-files-on-kill-emacs ()
> > +  "Delete the temp-files associated with the ediff buffers."
> > +  (ignore-errors
> > +    (let ((inhibit-interaction t))
> > +      (dolist (b (buffer-list))
> > +        (with-current-buffer b
> > +          (when (eq major-mode 'ediff-mode)
> > +            (ediff-delete-temp-files)))))))
> I think this is the same as mapping over `ediff-session-registry' which
>  should hold exactly the list of buffers we want.
>  Second: Can we move the `ignore-errors' inwards so that an error in one
> case doesn't abort the complete loop?

Sure, I had attached the modified one towards your comments.

> >  ;;; Setup functions
> >
> > @@ -488,6 +496,7 @@ ediff-setup
> >        (if (ediff-buffer-live-p ediff-meta-buffer)
> >          (ediff-update-meta-buffer
> >           ediff-meta-buffer nil ediff-meta-session-number))
> > +      (add-hook 'kill-emacs-hook #'ediff--delete-temp-files-on-kill-emacs)
> Would it be ok to avoid the above loop completely by using the buffer
>  local version of `kill-emacs-hook' instead?

I didn't found a local version of `kill-emacs-hook` example in emacs git repo. 
Current version also work for the killing from command line, for example executing a "pkill emacs" during ediff session.

From 5d21b65eaa45c996182ce3181b1289ed03ff1c26 Mon Sep 17 00:00:00 2001
From: Lin Sun <[email-masked]>
Date: Sun, 29 Dec 2024 06:55:01 +0000
Subject: [PATCH] * lisp/vc/ediff-util.el: Loop the ediff-session-registry
 instead of buffers

---
 lisp/vc/ediff-util.el | 9 ++++-----
 1 file changed, 4 insertions(+), 5 deletions(-)

diff --git a/lisp/vc/ediff-util.el b/lisp/vc/ediff-util.el
index 33666535843..d448973b345 100644
--- a/lisp/vc/ediff-util.el
+++ b/lisp/vc/ediff-util.el
@@ -219,12 +219,11 @@ ediff--delete-temp-files-on-kill-emacs
   ;; where this hook could prevent kill-emacs from shutting down Emacs,
   ;; because user interaction is not possible (e.g., in a daemon), or
   ;; if deleting these files signals an error.
-  (ignore-errors
-    (let ((inhibit-interaction t))
-      (dolist (b (buffer-list))
+  (let ((inhibit-interaction t))
+    (dolist (b ediff-session-registry)
+      (ignore-errors
         (with-current-buffer b
-          (when (eq major-mode 'ediff-mode)
-            (ediff-delete-temp-files)))))))
+          (ediff-delete-temp-files))))))
 
 ;;; Setup functions
 
-- 
2.34.1